/*
  LiquidCrystal Library - Hello World

 Demonstrates the use a 16x2 LCD display.  The LiquidCrystal
 library works with all LCD displays that are compatible with the
 Hitachi HD44780 driver. There are many of them out there, and you
 can usually tell them by the 16-pin interface.

 This sketch prints "Hello World!" to the LCD
 and shows the time.

  The circuit:
 * LCD RS pin to digital pin 12
 * LCD Enable pin to digital pin 11
 * LCD D4 pin to digital pin 5
 * LCD D5 pin to digital pin 4
 * LCD D6 pin to digital pin 3
 * LCD D7 pin to digital pin 2
 * LCD R/W pin to ground
 * 10K resistor:
 * ends to +5V and ground
 * wiper to LCD VO pin (pin 3)

 Library originally added 18 Apr 2008
 by David A. Mellis
 library modified 5 Jul 2009
 by Limor Fried (http://www.ladyada.net)
 example added 9 Jul 2009
 by Tom Igoe
 modified 22 Nov 2010
 by Tom Igoe

 This example code is in the public domain.

 http://www.arduino.cc/en/Tutorial/LiquidCrystal
 */
  
// include the library code:
#include <LiquidCrystal.h>

// initialize the library with the numbers of the interface pins

LiquidCrystal lcd(12, 11, 5, 4, 3, 2);
  //上次运行时间
unsigned long previousMillis = 0;
  //最小时间间隔
int INTERVAL = 1000;
//flag代表二种模式，0则停止，1则暂停
int flag = 0;

  long a = 0;
  long b = 0;
  long c = 0;
  long d = 0;
  long e = 0;
  long f = 0;
  long g = 0;
  long h = 0;

void setup() {
  pinMode (6,OUTPUT);
  Serial.begin(9600);
  // set up the LCD's number of columns and rows:
  lcd.begin(16, 2);
  // Print a message to the LCD.
  lcd.print("DS:    ");
  lcd.setCursor(7, 0);
  lcd.print("d >  /10s");
  lcd.setCursor(0, 1);
  lcd.print("SJ:    ");  
  lcd.setCursor(7, 1);
  lcd.print("s  YW: ");
  
}

void loop() 
{  
  SJ();
  DS();
  sdcs();
  gywt();
  keyScan();
}

void SJ()
{   
  if(flag == 1)
  {
  unsigned long currentMillis=millis();//当前运行时间
    if(currentMillis - previousMillis >= INTERVAL)
   {a++;
   if(a==10)
  {  
    a=0;
    b=1;
  }
   previousMillis=currentMillis;
  }
  if((a==1)&&(b==1))
  {
  a=0;
  b=0;
  delay(5000);
  c=0;
  d=0;
  }
  } 
  //Serial.println(a);
   //print the number of seconds since reset:
  lcd.setCursor(5, 1);
   lcd.print(a);
    lcd.setCursor(4, 1);
   lcd.print(b);  
}
void DS()
{
  Serial.print( analogRead(A2) );
  Serial.println("");
  if((analogRead(A2))>150)
  {
    c++;
    if(c==10)
    {
      d++;
      c=0;
    }
  }
    while((analogRead(A2))>150);
   lcd.setCursor(5, 0);
   lcd.print(c);
   lcd.setCursor(4, 0);
   lcd.print(d); 
  
}
void sdcs()
{
  if(analogRead(A0)>600)
   {
     delay(20);
     if(analogRead(A0)>600)
     {
       g++;
       if(g==10)
       {
         h++;
         g=0;
       }
       while(analogRead(A0)>600);
     }
   }
   if(analogRead(A1)>600)
   {
     delay(20);
     if(analogRead(A1)>600)
     {
       g--;
       if(g==-1)
       {
         h--;
         g=9;
         if((g==0)&&(h==0))
         {
         g=g;
         h=h;
         }
       }
       while(analogRead(A1)>600);
     }
   }
   lcd.setCursor(11, 0);
   lcd.print(g);
   lcd.setCursor(10, 0);
   lcd.print(h);
}
void gywt()
{
   Serial.print( analogRead(A3) );
  Serial.println("");
  if((analogRead(A3))>150)
  {
    digitalWrite(6,HIGH);
    lcd.setCursor(14, 1);
    lcd.print("Y");
  }
  else
  {
  digitalWrite(6,LOW);
  lcd.setCursor(14, 1);
  lcd.print("N");
  flag=0;
  }
}
 //按键扫描
void keyScan()
{
  if(analogRead(A4)>600)
   {
     delay(20);
     if(analogRead(A4)>600)
     { a=0;
       b=0;
       c=0;
       d=0;  
       flag++;
       if(flag>=2)
       {
         flag=0;
       }
       while(analogRead(A4)>600);
     }
   }
}
